unit jviewu;

// Pulsar jViewer Source Code (c)1999 Pulsar Studio, & Lord Trancos.
// Please distribute the source code without any modification.

// FREEWARE

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, Printers, StdCtrls, Menus, ExtCtrls, Buttons,
  ShellAPI, Nihongo;

type
  TForm1 = class(TForm)
    OpenDlg: TOpenDialog;
    PrtDlg: TPrintDialog;
    MainMenu1: TMainMenu;
    Menu1: TMenuItem;
    Menu2: TMenuItem;
    Menu3: TMenuItem;
    Menu4: TMenuItem;
    Menu5: TMenuItem;
    Menu6: TMenuItem;
    Menu7: TMenuItem;
    Menu8: TMenuItem;
    Menu9: TMenuItem;
    Menu10: TMenuItem;
    Menu11: TMenuItem;
    Menu12: TMenuItem;
    Panel1: TPanel;
    Scroll: TPaintBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Menu13: TMenuItem;
    Menu14: TMenuItem;
    Display: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure Menu2Click(Sender: TObject);
    procedure Menu3Click(Sender: TObject);
    procedure Menu6Click(Sender: TObject);
    procedure Menu4Click(Sender: TObject);
    procedure Menu8Click(Sender: TObject);
    procedure Menu9Click(Sender: TObject);
    procedure Menu10Click(Sender: TObject);
    procedure Menu11Click(Sender: TObject);
    procedure DisplayPaint(Sender: TObject);
    procedure ScrollClick(Sender: TObject);
    procedure Menu12Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ScrollPaint(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Menu13Click(Sender: TObject);
    procedure Menu14Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1     : TForm1;
  ChrSiz    : word;            // Charcter width n height
  ChrX      : longint;         // Left OffSet for Scroll L/R
  LinScr    : word;            // Lines in Screen
  ChrScr    : word;            // Max Char per Line
  lAdjust   : boolean = true;  // Use Line break
  PrtChrScr : word = 80;       // Max Chr per Line (Printer)
  WinMode   : boolean = true;  // Window Mode
  FrmInit   : boolean = false; // Form created
  FrmDraw   : boolean = true;  // Draw text
  ColorX    : boolean = true;
  ColorA    : longint = clWhite;
  ColorB    : longint = clRed;
  HFilter   : boolean = true;  // Hispa filter
  TSearch   : string = '';     // Default String for Searching

  OldWidth  : longint;         // Width  before change to FullScreen
  OldHeight : longint;         // Height before change to FullScreen
  OldTop    : longint;         // Top    before change to FullScreen
  OldLeft   : longint;         // Left   before change to FullScreen

  // File vars
  FFormat : byte;    // File format = 0 -> sjs / 1 -> euc / 2 ->jis
  JISON   : boolean = false;
  FName   : string;  // Filename
  FSize   : longint; // File size
  FData   : pointer; // File in memory
  FLoaded : boolean; // File loaded ?
  FLin    : longint; // First line drawed
  FLines  : longint; // Used to limit movement
  FPos    : longint; // File position
  FPages  : longint; // File Pages

const
  EOFDOS = $D;  // Do not change
  EOFWIN = $A;  // Do not change
  MINCHR = 20;  // Min. Number of Chars. per Line Printed
  MAXCHR = 140; // Max. Number of Chars. per Line Printed
  MINW   = 312; // Min. Window Width
  MINH   = 192; // Min. Window Height

  EUCEXT = '.EUC';  // default EUC extension
  SJSEXT = '.SJS';  // default SJS extension
  JISEXT = '.JIS';  // default JIS extension
  USEEUC = '-E'; // 2nd parameter, EUC (only required if file ext <> EUCEXT)
  USESJS = '-S'; // 2nd parameter, SJS (only required if file ext <> SJSEXT)
  USEJIS = '-J'; // 2nd parameter, JIS (only required if file ext <> JISEXT)

  ABOUT = 'Pulsar jViewer v0.4b - SJS/EUC/JIS* Viewer'+#10+
          '(c)1999 Pulsar Studio'+#10+
          'Developed by Lord Trancos'+#10+#10+
          'Keys;'+#10+
          '[ESC]'+#9+'Exit'+#10+
          '[F1]'+#9+'About/Help'+#10+
          '[F2]'+#9+'Open File'+#10+
          '[F3]'+#9+'Search Text'+#10+
          '[F5]'+#9+'Enable/Disable Line Wrap'+#10+
          '[F6]'+#9+'Change Colors'+#10+
          '[F7]'+#9+'Window/FullScreen Mode'+#10+
          '[F8]'+#9+'Minimize Window'+#10+
          '[F9]'+#9+'Chg. Max. # Chars. per Line Printed'+#10+
          '[F10]'+#9+'Print File'+#10+
           'And also; [ARROWS][PGUP][PGDOWN][BEGIN][END]'+#10+
//          '[UP][DOWN][LEFT][RIGHT]'+#9+'Scroll Text'+#10+
//          '[PGUP][PGDOWN]'+#9+'Page Up/Down'+#10+
//          '[BEGIN][END]'+#9+'Goto Begin/End'+#10+
//          '[SPACEBAR] - Redraw Text'+#10+
          #10+'Greetings to:'+#10+
          'Dark Shadow, Rnin, Multidimensional Careto,'+#10+
          'Takuya, Kanjiman, FidoNet r34.Japones, FIC BBS,'+#10+
          'DOKAN and ONELIST.COM MLJ (Mail List Japones)'+#10+#10+
          'This program is FREEWARE' + #10+
          'Full Source Code is Available for FREE!';

  CAP00 = '&File';
  CAP01 = '&Open';
  CAP02 = '&Print';
  CAP03 = 'E&xit';
  CAP04 = '&Help';
  CAP05 = '&About/Keys';
  CAP06 = '&Display';
  CAP07 = '&FullScreen';
  CAP08 = 'Enable Line &Wrap';
  CAP09 = 'Disable Line &Wrap';
  CAP10 = '&Redraw';
  CAP11 = '&Change Colors';
  CAP12 = 'Disable &HispaFilter';
  CAP13 = 'Enable &HispaFilter';
  CAP14 = '&Search Text';
  CAP15 = 'MS-&DOS';

  TXT00 = 'Can not open file: ';
  TXT01 = 'Can not load file: ';
  TXT02 = 'Error while initializing Nihongo Engine!'+#10+
          '(Remerber: '+jJAPFNT+' and '+jASCFNT+
          ' must be in program''s folder!)';
  TXT03 = '>> LOADING';
  TXT04 = 'File empty: ';
  TXT05 = ' PULSAR jVIEWER - ';
  TXT06 = 'File format not specified.';
  TXT07 = ' - page: ';
  TXT08 = ' - line: ';
  TXT09 = 'Top/Left: (';
  TXT10 = ') - Pos: ';
  TXT11 = 'Printing... ';
  TXT12 = 'Counting... ';
  TXT13 = '%';
  TXT15 = 'Lines: ';
  TXT16 = 'Skiping ';
  TXT17 = 'Printing ';
  TXT18 = 'Change number of characters per line';
  TXT19 = 'How many (range: 20-140)?';
  TXT20 = 'Out of range!';
  TXT21 = 'Loading... ';
  TXT22 = 'done!';
  TXT23 = 'Searching... ';
  TXT24 = 'Search Text (from Current Position)';
  TXT25 = 'Text to find';
  NHG00 = #$93 + #$FA + #$96 + #$7B + #$8C + #$EA;

implementation

uses jViewu2;

{$R *.DFM}

// -----------------------------------------------------------------------

procedure ErrH(_err: string);

begin
  MessageDlg(_err, mtError, [mbOk], 0);
  Halt;
end;

// -----------------------------------------------------------------------

procedure IncPtrPox(var _ptr: pointer; var _pos: longint; _val: longint);

begin
  inc(longint(_ptr), _val);
  inc(_pos, _val);
end;

// -----------------------------------------------------------------------

procedure DecPtrPox(var _ptr: pointer; var _pos: longint; _val: longint);

begin
  dec(longint(_ptr), _val);
  dec(_pos, _val);
end;

// -----------------------------------------------------------------------

procedure DrawScrollBar(_w: longint);

begin
  Form1.Scroll.Canvas.Brush.Color := ColorA;
  Form1.Scroll.Canvas.Rectangle(_w, 0,
                                Form1.Scroll.Width,
                                Form1.Scroll.Height);
  Form1.Scroll.Canvas.Brush.Color := ColorB;
  Form1.Scroll.Canvas.Rectangle(0, 0, _w + 1,
                                Form1.Scroll.Height);
end;

// -----------------------------------------------------------------------

function GetSrollBarWidth: longint;

var _l : longint;
    _p, _s : longint;
    _z : byte;

begin
  if FSize > 102400 then _z := 10 else _z := 0;

  _p := FPos shr _z;
  _s := FSize shr _z;

  _l := ((Form1.Scroll.Width - 1) * _p) div _s;

  GetSrollBarWidth := _l;
end;

// -----------------------------------------------------------------------

procedure CheckJIS(var _ptr: pointer; var _pos: longint);

begin
  if byte(_ptr^) = $1B then
    begin
      if JISON = true
        then JISON := false
          else JISON := true;
      IncPtrPox(_ptr, _pos, 3);
    end;
end;

// -----------------------------------------------------------------------

function GetCurrentLine(var _ptr: pointer; var _pos: longint;
                        _chrscr: word): string;

var _s: string;
    _l: longint;
    _b: byte;
    _z: word;

begin
  _l := 0;
  _s := '';

  if lAdjust = false then // Whitout Line break
    begin
      while (byte(_ptr^) <> EOFDOS) and (byte(_ptr^) <> EOFWIN)
        and (_pos < FSize) do
          begin
            inc(_l);

            if FFormat = 2 then CheckJIS(_ptr, _pos);

            if (byte(_ptr^) <> EOFDOS) and (byte(_ptr^) <> EOFWIN)
            and (_l >= ChrX) and (length(_s) <= _chrScr) then
              if JISON = false then _s := _s + char(_ptr^)
                else _s := _s + char(byte(_ptr^)+128);

            IncPtrPox(_ptr, _pos, 1);
          end;
    end else begin        // Whit Line break
               while (byte(_ptr^) <> EOFDOS) and (byte(_ptr^) <> EOFWIN)
                 and (_pos < FSize) and (length(_s) <= _chrScr) do
                   begin
                     inc(_l);

                     if FFormat = 2 then CheckJIS(_ptr, _pos);

                     if (_l >= ChrX) and (byte(_ptr^) <> EOFDOS)
                       and (byte(_ptr^) <> EOFWIN)then
                         if JISON = false then _s := _s + char(_ptr^)
                           else _s := _s + char(byte(_ptr^)+128);

                     IncPtrPox(_ptr, _pos, 1);
                   end;

               if (length(_s) = _chrScr + 1)
                 then DecPtrPox(_ptr, _pos, 1);

               if (length(_s) = _chrScr + 1) then
                 begin
                   _z := length(_s);
                   if FFormat = 0
                     then _s := jBreak(_s, jSJS, _chrScr)
                       else _s := jBreak(_s, jEUC, _chrScr);
                   if length(_s) < _z
                     then DecPtrPox(_ptr, _pos, _z - length(_s) - 1);
                 end;

               if char(_ptr^) = ' ' then IncPtrPox(_ptr, _pos, 1);
             end;

  case byte(_ptr^) of
    EOFDOS : _b := 2;
    EOFWIN : _b := 1;
    else _b := 0;
  end;

  if _pos < FSize then IncPtrPox(_ptr, _pos, _b);

{  if _pos = FSize // ***
    then FLines := FLin else IncPtrPox(_ptr, _pos, _b); }

  GetCurrentLine := _s;
end;

// -----------------------------------------------------------------------

procedure zRect(_canvas: tCanvas;
                _x1, _y1, _x2, _y2, _color: longint);

var _oldp: longint;
    _oldb: longint;

begin
  if (_x1 > _x2) or (_y1 > _y2) then exit;
  _oldp := _canvas.Pen.Color;
  _oldb := _canvas.Brush.Color;
  _canvas.Pen.Color := _color;
  _canvas.Brush.Color := _color;
  _canvas.Rectangle(_x1, _y1, _x2, _y2);
  _canvas.Pen.Color := _oldp;
  _canvas.Brush.Color := _oldb;
end;

// -----------------------------------------------------------------------

procedure DrawText(_zeta: byte);

var _line  : byte;
    _s     : string;
    _point : pointer;
    _pos   : longint;
    _y     : longint;
    _perc  : longint;

begin
  _perc := (FPos * 100) div FSize;
  _s := TXT05 + FName + ' - '{ + TXT09 + IntToStr(FLin) + '/' + IntToStr(ChrX)}
      {+ TXT10 + IntToStr(FPos) + } + IntToStr(_perc) + '% ';
  if lAdjust = true then _s := _s + 'W';

  if WinMode = false then
    begin
      jWrite(0, 0, ChrSiz, ChrSiz, _s, jSJS, false, not ColorX,
            hFilter, Form1.Display.Canvas.handle);
//      Form1.Display.Canvas.Pen.Color := ColorA xor $FFFFFF;
//      Form1.Display.Canvas.Brush.Color := ColorA xor $FFFFFF;
      zRect(Form1.Display.Canvas,
            length(_s) * ChrSiz shr 1, 0,
            Form1.Display.width, ChrSiz, ColorA xor $FFFFFF);

//      Form1.Display.Canvas.Pen.Color := ColorA;
//      Form1.Display.Canvas.Brush.Color := ColorA;
    end else Form1.Caption := _s;

  DrawScrollBar(GetSrollBarWidth);

  _line  := 1;
  _pos   := FPos;
  _point := FData;
  inc(longint(_point), _pos);
  repeat
    _s := GetCurrentLine(_point, _pos, ChrScr);
    if (_zeta = 0) or                         // Draw all
       ((_zeta = 1) and (_line = 1)) or       // Draw only first line
       ((_zeta = 2) and (_line = LinScr - 1)) // Draw only last line
       then begin
              _y := (_line * ChrSiz);
              if WinMode = true then dec(_y, ChrSiz);
//              Form1.Display.Canvas.Pen.Color := ColorA;
//              Form1.Display.Canvas.Brush.Color := ColorA;
              zRect(Form1.Display.Canvas,
                    length(_s) * ChrSiz shr 1, _y,
                    Form1.Display.width, _y + ChrSiz, ColorA);
//              Form1.Display.Canvas.Pen.Color := ColorA xor $FFFFFF;
//              Form1.Display.Canvas.Brush.Color := ColorA xor $FFFFFF;
              if FFormat = 0
                then jWrite(0, _y, ChrSiz, ChrSiz, _s, jSJS, false,
                            ColorX, hFilter, Form1.Display.Canvas.handle)
                  else jWrite(0, _y, ChrSiz, ChrSiz, _s, jEUC, false,
                              ColorX, hFilter, Form1.Display.Canvas.handle);
            end;
    inc(_line);
  until _line = LinScr;
  inc(_y, ChrSiz);
//  Form1.Display.Canvas.Brush.Color := clRed;
  if _zeta = 0 then zRect(Form1.Display.Canvas, 0, _y,
                          Form1.Display.width, _y + ChrSiz, ColorA);
//  Form1.Display.Canvas.Brush.Color := ColorA;
end;

// -----------------------------------------------------------------------

procedure RedrawDisplay;

begin
  if (FLoaded = true) and (FrmDraw = true) then DrawText(0);
end;

// -----------------------------------------------------------------------

procedure LineBack(var _ptr: pointer; var _pos: longint);

begin
  if (FPos = 0) {or (Flin = 1)} then exit;

  if (FPos > 2) then
    begin
      dec(longint(_ptr), 2);
      dec(_pos, 2);
    end else begin FPos := 0; _ptr := FData; exit; end;

  while (byte(_ptr^) <> EOFWIN) and (FPos > 0) do
    begin
      dec(longint(_ptr));
      dec(_pos);
    end;

  if FPos <> 0 then
    begin
      inc(longint(_ptr));
      inc(_pos);
    end;
end;

// -----------------------------------------------------------------------

procedure LineBack2(var _ptr: pointer; var _pos: longint);

var _old   : longint;
    _z, _c : longint;

begin
  _z   := 0;
  _old := _pos;
  LineBack(_ptr, _pos);
  while _pos < _old do
      begin
        GetCurrentLine(_ptr, _pos, ChrScr);
        inc(_z);
      end;
    LineBack(_ptr, _pos);
    if _z > 1 then
      for _c := 1 to _z - 1
        do GetCurrentLine(_ptr, _pos, ChrScr);
end;

// -----------------------------------------------------------------------

function LineDown: boolean;

var _p: pointer;
    _x: longint;

begin
  LineDown := false;

{  if Flines <> 0 then if FLin >= FLines then exit; }
  _x := FPos;
  _p := FData;
  inc(longint(_p), FPos);
  GetCurrentLine(_p, FPos, ChrScr);
{  if FPos > _x then inc(FLin); }

  LineDown := true;
end;

// -----------------------------------------------------------------------

function LineUp: boolean;

var _p: pointer;
    _x: longint;

begin
  LineUp := false;

  if FPos = 0 then exit;
{  if FLin = 1 then exit; }
  _x := FPos;
  _p := FData;
  inc(longint(_p), FPos);
  if lAdjust = false
    then LineBack(_p, FPos)
      else LineBack2(_p, FPos);
{  if FPos < _x then dec(FLin); }

  LineUp := true;
end;

// -----------------------------------------------------------------------

procedure SoftScroll(_down: boolean);

var _pos: integer;
    _zzz: integer;
    _xxx: integer;

begin
  if _down = true then
    begin
       _xxx := 0;
       _zzz := 0;
       if WinMode = true then _zzz := ChrSiz else _xxx := ChrSiz;
       BitBlt(Form1.Display.Canvas.Handle, 0, ChrSiz - _zzz,
              Form1.Display.Width, ((LinScr - 1) * ChrSiz) - _zzz - _xxx,
              Form1.Display.Canvas.Handle, 0, (ChrSiz shl 1) - _zzz,
              SRCCOPY);
    end else begin
               if WinMode = true then _zzz := 0 else _zzz := 1;
               for _pos := LinScr - 3 + _zzz downto _zzz do
                 BitBlt(Form1.Display.Canvas.Handle, 0,
                       (((_pos + 1) * ChrSiz)), Form1.Display.Width,
                       ChrSiz, Form1.Display.Canvas.Handle,
                       0, (_pos * ChrSiz), SRCCOPY);
             end;
end;

// -----------------------------------------------------------------------

function IdentifyFileType(_fn: string): boolean;

var _ex : string[4];
    _r  : boolean;

begin
  _r := true;
  _ex := UpperCase(ExtractFileExt(_fn));
  if _ex = SJSEXT then FFormat := 0 else
    if _ex = EUCEXT then FFormat := 1 else
      if _ex = JISEXT then FFormat := 2 else _r := false;
  IdentifyFileType := _r;
end;

// -----------------------------------------------------------------------

procedure ChkFileFormat;

begin
  case Form1.OpenDlg.FilterIndex of
    1: if IdentifyFileType(Form1.OpenDlg.Filename) = false
         then ErrH(TXT06);
    2: FFormat := 0;
    3: FFormat := 1;
    4: FFormat := 2;
  end;
end;

// -----------------------------------------------------------------------

function UseOpenDialog: string;

begin
  if Form1.OpenDlg.Execute = false then Halt;
  ChkFileFormat;
  UseOpenDialog := Form1.OpenDlg.Filename;
end;

// -----------------------------------------------------------------------

function GetFileSize(_fn: string): longint;

var _r: longint;
    _f: file;

begin
  if jOpenBinFile(_fn, _f) = false then ErrH(TXT00 + _fn);
  _r := filesize(_f);
  CloseFile(_f);
  GetFileSize := _r;
end;

// -----------------------------------------------------------------------

procedure InitVars1;

begin
  FPos    := 0;
{  FLin    := 1; }
  ChrX    := 1;
  FLines  := 0;
end;

// -----------------------------------------------------------------------

procedure ResizeJViewer;

begin
  if IsWindow(Form1.handle) = true then
    begin
{      Form1.Visible := false; }
      FrmDraw := false;
      InitVars1;
      if Screen.Width < 1280 then ChrSiz := 16 else ChrSiz := 32;
      ChrScr := Form1.Display.Width div (ChrSiz shr 1);
      if Form1.BorderStyle = bsNone then
        begin
{          ChrScr := Form1.Display.Width div (ChrSiz shr 1);}
          LinScr := Form1.Display.Height div ChrSiz;
        end else begin
{                   ChrScr := Form1.Display.Width div (ChrSiz shr 1); }
                   LinScr := (Form1.Display.Height + 12) div ChrSiz;
                 end;

{     FLines := 0; }
      FrmDraw := true;
{      Form1.Visible := true; }
    end;
  Form1.Scroll.Width := Form1.Panel1.Width - Form1.Scroll.Left - 8;    
end;

// -----------------------------------------------------------------------

procedure ChangeWinMode(_backup: boolean);

begin
  if WinMode = false then
    begin
      // Restore Top/Left/Width/Height
      if _backup = true then
        begin
          Form1.Top := OldTop;
          Form1.Left := OldLeft;
          Form1.Width := OldWidth;
          Form1.Height := OldHeight;
        end;
      // Change to Window Mode
      WinMode := true;
      Form1.BorderStyle := bsSizeable;
      Form1.Menu1.Visible := true;
      Form1.Menu5.Visible := true;
      Form1.Menu7.Visible := true;
      Form1.Panel1.Visible := true;
      ResizeJViewer;
    end else begin
               // Save Top/Left/Width/Height
               if _backup = true then
                 begin
                   OldTop := Form1.Top;
                   OldLeft := Form1.Left;
                   OldWidth := Form1.Width;
                   OldHeight := Form1.Height;
                 end;
               // Change to FullScreen Mode
               WinMode := false;
               Form1.BorderStyle := bsNone;
               Form1.Menu1.Visible := false;
               Form1.Menu5.Visible := false;
               Form1.Menu7.Visible := false;
               Form1.Panel1.Visible := false;
               Form1.Left := 0;
               Form1.Top := 0;
               Form1.Width := Screen.Width;
               Form1.Height := Screen.Height;
               ResizeJViewer;
             end;
end;

// -----------------------------------------------------------------------

procedure TForm1.FormCreate(Sender: TObject);

begin
  // Init Menu
  Form1.Menu1.Caption := CAP00;
  Form1.Menu2.Caption := CAP01;
  Form1.Menu3.Caption := CAP03;
  Form1.Menu4.Caption := CAP02;
  Form1.Menu5.Caption := CAP04;
  Form1.Menu6.Caption := CAP05;
  Form1.Menu7.Caption := CAP06;
  Form1.Menu8.Caption := CAP07;
  Form1.Menu9.Caption := CAP09;
  Form1.Menu10.Caption := CAP10;
  Form1.Menu11.Caption := CAP11;
  Form1.Menu12.Caption := CAP12;
  Form1.Menu13.Caption := CAP14;
  Form1.Menu14.Caption := CAP15;

  // Init vars
  InitVars1;
  FPages  := 0;
  FLoaded := false;

  // Set size
  ChangeWinMode(false);

  // init n display form
  Form1.BorderStyle := bsNone;
  Form1.Color  := clBlack;
  Form1.Canvas.Brush.Color := clWhite;
  Form1.Top    := (Screen.Height shr 1) - 30;
  Form1.Left   := (Screen.Width shr 1) - 50;
  Form1.Height := 60;
  Form1.Width  := 100;
  ShowWindow(Form1.handle, SW_SHOW);

  // init nihongo engine
  if jInitialize = false then ErrH(TXT02 + #10 + paramstr(0));

  // draw 'Loading...' banner
  jWrite(0, 4, 32, 32, NHG00, jSJS, false, false, hFilter,
         Form1.Canvas.handle);
  jWrite(8, 40, 16, 16, TXT03, jSJS, false, false, hFilter,
         Form1.Canvas.handle);

  // Choose file n file format
  FFormat := 0;
  if paramcount = 0 then
    begin
      FName := UseOpenDialog
    end else begin
               FName := paramstr(1);
               if IdentifyFileType(FName) = false then
                 if (paramcount > 1) then
                   begin
                     if UpperCase(paramstr(2)) = USESJS
                       then FFormat := 0
                         else if UpperCase(paramstr(2)) = USEEUC
                           then FFormat := 1
                             else if UpperCase(paramstr(2)) = USEJIS
                               then FFormat := 2
                                 else FName := UseOpenDialog;
                   end else FName := UseOpenDialog;
             end;

  // draw 'Loading...' banner (yes, another time)
  jWrite(0, 4, 32, 32, NHG00, jSJS, false, false, hFilter,
         Form1.Canvas.handle);
  jWrite(8, 40, 16, 16, TXT03, jSJS, false, false, hFilter,
         Form1.Canvas.handle);

  // check file
  FSize := GetFileSize(FName);
  if FSize = 0 then ErrH(TXT04 + FName);

  // Load file in memory
  GetMem(FData, FSize);
  if jLoadFile(FName, FData) = false then ErrH(TXT01 + FName);
  FLoaded := true;

  // Get only the file name
  Fname := ExtractFileName(FName);

  // Init Form
  ShowWindow(Form1.handle, SW_HIDE);
  Form1.Display.Canvas.Pen.Color := ColorA;
  Form1.Color := ColorA;
  Form1.Top := 0;
  Form1.Left := 0;
  Form1.Width := Screen.Width + 8;
  Form1.Height := Screen.Height;
  ChangeWinMode(false);
  Dec(LinScr);
  ShowWindow(Form1.handle, SW_MAXIMIZE);
  FrmInit := true;
(*
  // Init form
  Form1.rePaint; *)

//  Form1.FormStyle := fsStayOnTop;
end;

// -----------------------------------------------------------------------

procedure CountPages(_chrscr: word);

var _p   : pointer;
    _l   : longint;
    _lin : longint;
    _chrsiz  : word;
    _pagelin : word;
    _perc : longint;
    _oldp : longint;

begin
  _l := 0;
  _p := FData;
  _lin := 0;
  bAbort := false;
  Form1.Enabled := false;
  Form2.Caption := TXT12;
  Form2.Visible := true;
  _oldp := -1;
  while (_l < FSize) and (bAbort = false) do
    begin
      // Display %
      _perc := (_l * 100) div FSize;
      if _oldp <> _perc then
        begin
          Application.ProcessMessages;
          Form2.Caption := TXT12 + IntToStr(_perc) + TXT13;
          Form2.Label1.Caption := TXT15 + IntToStr(_lin);
        end;
      _oldp := _perc;

      // Next line
      GetCurrentLine(_p, _l, _chrScr);
      inc(_lin);
    end;
  if bAbort = false then
    begin
      _chrsiz  := Printer.PageWidth div (PRTCHRSCR shr 1); {(Printer.PageWidth * 16) div 640;}
      _pagelin := Printer.Pageheight div _chrsiz;
      FPages   := _lin div _pagelin;
      if _lin mod _pagelin <> 0 then inc(FPages);
    end;
  Form2.Visible := false;
  Form1.Enabled := true;
  Form1.SetFocus;
end;

// -----------------------------------------------------------------------

procedure PrtTxt(_page, _line: longint; _plus: string);

begin
  Form2.Label1.Caption := _plus + TXT07 + IntToStr(_page) + TXT08
                        + IntToStr(_line);
end;

// -----------------------------------------------------------------------

procedure PrintIt;

var _pos     : longint;
    _line    : longint;
    _page    : longint;
    _point   : pointer;
    _s       : string;
    _chrsiz  : word;
    _pagelin : word;
    _xyz     : longint;

    _from    : longint;
    _to      : longint;

begin
  // Count pages if required
  if FPages = 0 then CountPages(PRTCHRSCR);
  if FPages = 0 then exit;

  // Prt Dialog
  Form1.PrtDlg.MinPage := 1;
  Form1.PrtDlg.MaxPage := FPages;
  Form1.PrtDlg.FromPage := 1;
  Form1.PrtDlg.ToPage   := FPages;
  if Form1.PrtDlg.Execute = false then exit;

  // Set _copies, _from & _to
  if Form1.PrtDlg.PrintRange = prPageNums then
    begin
      _from := Form1.PrtDlg.FromPage;
      _to   := Form1.PrtDlg.ToPage;
    end else begin
               _from   := 1;
               _to     := FPages;
             end;

  // Reset Left Pos (ir required)
  if ChrX <> 1 then
    begin
      ChrX := 1;
//      Form1.Display.RePaint;
      RedrawDisplay;
    end;

  // Init some values
  bAbort := false;
  _pos   := 0;
  _point := FData;
  _page  := 1;
  _chrsiz  := Printer.PageWidth div (PRTCHRSCR shr 1);
  _pagelin := Printer.Pageheight div _chrsiz;
  Form1.Enabled := false;
  Form2.Caption := TXT11;
  Form2.Visible := true;

  // Print
  Printer.BeginDoc;
  Printer.Canvas.Pen.Color := clBlack;
  Printer.Canvas.Brush.Color := clWhite;
  repeat
    _line   := 1;
    repeat // Print current page
      Application.ProcessMessages;
      if _page < _from
        then PrtTxt(_page, _line, TXT16)
          else PrtTxt(_page, _line, TXT17);

      _xyz := _pos;
      _s   := GetCurrentLine(_point, _pos, PRTCHRSCR);
      if _page >= _from then
        if FFormat = 0
          then jWrite(0, _line * _chrSiz, _chrSiz, _chrSiz, _s, jSJS,
                      false, true, hFilter, Printer.Canvas.handle)
            else jWrite(0, _line * _chrSiz, _chrSiz, _chrSiz, _s, jEUC,
                        false, true, hFilter, Printer.Canvas.handle);
      inc(_line);
    until (_line = _pagelin) or (_pos = _xyz) or (bAbort = true);
    if (_page >= _from) and (_page < _to) then Printer.NewPage;
    inc(_page);
  until (_pos = _xyz) or (bAbort = true) or (_page > _to);
  if bAbort = true then Printer.Abort else Printer.EndDoc;

  // Done
  Form2.Visible := false;
  Form1.Enabled := true;
  Form1.SetFocus;
end;

// -----------------------------------------------------------------------

procedure UnloadCurrentFile;

begin
  if FLoaded = true then FreeMem(FData, FSize);
end;

// -----------------------------------------------------------------------

procedure OpenAnotherFile;

var _sz : longint;

begin
  if Form1.OpenDlg.Execute = false then exit;
  _sz := GetFileSize(Form1.OpenDlg.Filename);
  if _sz = 0 then
    begin
      ShowMessage(TXT04 + Form1.OpenDlg.Filename);
      exit;
    end;
  ChkFileFormat;
  UnloadCurrentFile;
  InitVars1;
  FPages  := 0;
  FLoaded := false;
  FName := Form1.OpenDlg.Filename;
  FSize := _sz;

  // Load file in memory
  Form1.Caption := TXT21;
  GetMem(FData, FSize);
  if jLoadFile(FName, FData) = false then ErrH(TXT01 + FName);
  FLoaded := true;
  Form1.Caption := Form1.Caption + TXT22;

  // Get only the file name
  Fname := ExtractFileName(FName);

  // Redraw form
//  Form1.Display.Repaint;
  RedrawDisplay;
end;

// -----------------------------------------------------------------------

procedure ChangeLineWrap;

begin
  if lAdjust = false then
    begin
      lAdjust := true;
      Form1.Menu9.Caption := CAP09;
    end else begin
               lAdjust := false;
               Form1.Menu9.Caption := CAP08;
             end;
  InitVars1;
  FPages  := 0;
//  Form1.Display.repaint;
  RedrawDisplay;
end;

// -----------------------------------------------------------------------

procedure ChangeColors;

begin
  if ColorX = true then
    begin
      ColorX := false;
      ColorA := clBlack;
      ColorB := clBlue;
    end else begin
               ColorX := true;
               ColorA := clWhite;
               ColorB := clRed;
             end;
  Form1.Color := ColorA;
  Form1.Display.Canvas.Pen.Color := ColorA;
//  Form1.Display.Repaint;
//  RedrawDisplay;
end;

// -----------------------------------------------------------------------

procedure KeyUpPressed;

var _z : longint;

begin
  if LineUp = true then   // Up
    begin
      if WinMode = true then _z := ChrSiz else _z := 0;
      SoftScroll(false);
{      Form1.Display.Canvas.Brush.Color := ColorA;
      Form1.Display.Canvas.Rectangle(0, ChrSiz - _z,
                                     Form1.Display.Width,
                                     (ChrSiz shl 1) - _z);
      Form1.Display.Canvas.Brush.Color := clWhite; }
      DrawText(1);
    end else beep;
end;

// -----------------------------------------------------------------------

procedure KeyDownPressed;

var _z : longint;

begin
  if LineDown = true then // Down
    begin
      if WinMode = true then _z := ChrSiz else _z := 0;
      SoftScroll(true);
{      Form1.Display.Canvas.Brush.Color := ColorA;
      Form1.Display.Canvas.Rectangle(
                            0, ((LinScr - 1) * ChrSiz) -_z,
                            Form1.Display.Width,
                            Form1.Display.Height);
      Form1.Display.Canvas.Brush.Color := clWhite; }
      DrawText(2);
   end else beep;
end;

// -----------------------------------------------------------------------

procedure PgUpPressed;

var _z : longint;
    _cnt : word;

begin
  _z := Fpos;
  for _cnt := 3 to LinScr do LineUp;
  if FPos <> _z then {Form1.Display.repaint} RedrawDisplay else Beep;
end;

// -----------------------------------------------------------------------

procedure PgDownPressed;

var _z : longint;
    _cnt : word;

begin
  _z := Fpos;
  for _cnt := 3 to LinScr do LineDown;
  if FPos <> _z then {Form1.Display.repaint} RedrawDisplay else Beep;
end;

// -----------------------------------------------------------------------

procedure SearchString;

var _str: string;
    _p : pointer;
    _old : longint;
    _perc : longint;
    _oldp : longint;

begin
  _p := FData;
  inc(longint(_p), FPos);

  _str := '';
  _old := -1;
  _oldp := -1;
  TSearch := UpperCase(InputBox(TXT24, TXT25, TSearch));
  if TSearch = '' then exit;

  while (Pos(TSearch, _str) = 0) and (FPos <> _old) do
    begin
      _old := FPos;
      _str := UpperCase(GetCurrentLine(_p, FPos, ChrScr));

      // Display %
      _perc := (FPos * 100) div FSize;
      if _oldp <> _perc then
        begin
          Form1.Caption := TXT23 + IntToStr(_perc) + '%  ';
          DrawScrollBar(GetSrollBarWidth);
        end;
      _oldp := _perc;
    end;
  LineUp;
//  Form1.Display.Repaint;
  RedrawDisplay;
end;

// -----------------------------------------------------------------------

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
                             Shift: TShiftState);

var _cnt : word;
    _xyz : longint;
    _z   : longint;

begin
{  case key of
    27 : Application.Terminate; // Esc
    112: ShowMessage(ABOUT);    // F1
    113: OpenAnotherFile;       // F2
  end;
 }
  if FLoaded = true then
    case key of
{      32 : begin
             ChrX := 1;
             Form1.Display.repaint;  // SpaceBar
           end;
      8  : begin  // BackSpace
             if FFormat < 2 then inc(FFormat) else FFormat := 0;
             Form1.repaint;
           end; }
      36 : begin // Begin
             FPos := 0;
//             Display.Repaint;
             RedrawDisplay;
           end;
      35 : begin // End
             FPos := FSize;
             PgUpPressed;
//             Display.Repaint;
//             RedrawDisplay;
           end;
      33 : PgUpPressed; // PgUp
      34 : PgDownPressed; // PgDown
      38 : KeyUpPressed; // Up
      40 : KeyDownPressed; // Down
      37 : if (lAdjust = false) and (ChrX > 1) then // left
             begin
               dec(ChrX, ChrScr shr 1);
//               Form1.Display.repaint;
               RedrawDisplay;
             end;
      39 : if lAdjust = false then // right
             begin
               inc(ChrX, ChrScr shr 1);
//               Form1.Display.repaint;
               RedrawDisplay;
             end;
{      114: SearchString; // F3
      116: ChangeLineWrap; // F5
      117: ChangeColors; // F6
      118: begin // F7
             Form1.Visible := false;
             ChangeWinMode(true);
             Form1.Visible := true;
           end; }
      119: ShowWindow(Form1.handle, SW_MINIMIZE); // F8
      120: begin // F9
             _z := StrToInt(InputBox(TXT18, TXT19, IntToStr(PrtChrScr)));
             if (_z < MINCHR) or (_z > MAXCHR)
               then ShowMessage(TXT20)
                 else if PrtChrScr <> _z then
                   begin
                     FPages := 0;
                     PrtChrScr := _z;
                   end;
           end;
{      121: PrintIt; // F10 }
//      else ShowMessage(IntToStr(key));
    end;
end;

// -----------------------------------------------------------------------

procedure TForm1.FormPaint(Sender: TObject);

begin
//  if (FLoaded = true) and (FrmDraw = true) then DrawText(0);
end;

// -----------------------------------------------------------------------

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);

begin
  UnloadCurrentFile;
  jClose;
end;

// -----------------------------------------------------------------------

procedure TForm1.FormResize(Sender: TObject);

begin
  FrmDraw := false;
  if FrmInit = true then
    begin
      FrmDraw := false;
      if (Form1.Width < MINW) then Form1.Width := MINW;
      if (Form1.Height < MINH) then Form1.Height := MINH;
      ResizeJViewer;
    end;
  FrmDraw := true;
  Form1.Display.Repaint;
//  RedrawDisplay;
end;

// -----------------------------------------------------------------------

procedure TForm1.Menu2Click(Sender: TObject);

begin
  OpenAnotherFile;
end;

// -----------------------------------------------------------------------

procedure TForm1.Menu3Click(Sender: TObject);

begin
  Application.Terminate;
end;

// -----------------------------------------------------------------------

procedure TForm1.Menu6Click(Sender: TObject);

begin
  ShowMessage(ABOUT);
end;

// -----------------------------------------------------------------------

procedure TForm1.Menu4Click(Sender: TObject);

begin
  PrintIt;
end;

// -----------------------------------------------------------------------

procedure TForm1.Menu8Click(Sender: TObject);

begin
  Form1.Visible := false;
  ChangeWinMode(true);
  Form1.Visible := true;
end;

// -----------------------------------------------------------------------

procedure TForm1.Menu9Click(Sender: TObject);

begin
  ChangeLineWrap;
end;

// -----------------------------------------------------------------------

procedure TForm1.Menu10Click(Sender: TObject);

begin
//  Form1.Display.Repaint;
  RedrawDisplay;
end;

// -----------------------------------------------------------------------

procedure TForm1.Menu11Click(Sender: TObject);

begin
  ChangeColors;
end;

// -----------------------------------------------------------------------

procedure TForm1.DisplayPaint(Sender: TObject);

begin
  RedrawDisplay;
(*  if (FLoaded = true) and (FrmDraw = true) then
    begin
      DrawText(0);
    //  DrawScrollBar(GetSrollBarWidth);
    end;
    *)
end;

// -----------------------------------------------------------------------

procedure SetPos(_w: longint);

var _z : byte;
    _s : longint;
    _l : longint;
    _p : pointer;

begin
  if lAdjust = false then exit;

  if (_w < 0) or (_w > Form1.Scroll.Width) then exit;

  if FSize > 102400 then _z := 10 else _z := 0;

  _s := FSize shr _z;
  _l := (_w * _s) div Form1.Scroll.Width;

  FPos := _l shl _z;
  _p := FData;
  inc(longint(_p), FPos);

  if lAdjust = true then
    begin
      LineBack2(_p, FPos);
      if LineUp = true then DrawText(1);
    end;

//  Form1.Repaint;
  RedrawDisplay;
end;

// -----------------------------------------------------------------------

procedure TForm1.ScrollClick(Sender: TObject);

var _z: tPoint;

begin
  GetCursorPos(_z);
  If WinMode = true then dec(_z.x, 4);
//  DrawScrollBar(_z.x - Scroll.Left - Form1.Left);
  SetPos(_z.x - Scroll.Left - Form1.Left);
end;

// -----------------------------------------------------------------------

procedure TForm1.Menu12Click(Sender: TObject);

begin
  if hFilter = false then
    begin
      hFilter := true;
      Form1.Menu12.Caption := CAP12;
    end else begin
               hFilter := false;
               Form1.Menu12.Caption := CAP13;
             end;
//  Display.RePaint;
  RedrawDisplay;
end;

// -----------------------------------------------------------------------

procedure TForm1.SpeedButton1Click(Sender: TObject);

begin
  KeyUpPressed;
end;

// -----------------------------------------------------------------------

procedure TForm1.SpeedButton2Click(Sender: TObject);

begin
  KeyDownPressed;
end;

// -----------------------------------------------------------------------

procedure TForm1.ScrollPaint(Sender: TObject);

begin
  DrawScrollBar(GetSrollBarWidth);
end;

// -----------------------------------------------------------------------

procedure TForm1.SpeedButton3Click(Sender: TObject);

begin
  PgUpPressed;
end;

// -----------------------------------------------------------------------

procedure TForm1.SpeedButton4Click(Sender: TObject);

begin
  PgDownPressed;
end;

// -----------------------------------------------------------------------

procedure TForm1.Menu13Click(Sender: TObject);

begin
  SearchString;
end;

// -----------------------------------------------------------------------

procedure TForm1.Menu14Click(Sender: TObject);

begin
  ShellExecute(Form1.handle, 'open', 'command.com', NIL, NIL, SW_SHOW);
end;

// -----------------------------------------------------------------------

end.

